/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDmElementS4Record;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDmElementS4 extends TableImpl<VDmElementS4Record> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dm_element_s4</code>
     */
    public static final VDmElementS4 V_DM_ELEMENT_S4 = new VDmElementS4();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDmElementS4Record> getRecordType() {
        return VDmElementS4Record.class;
    }

    /**
     * The column <code>common_dd.v_dm_element_s4.tree</code>.
     */
    public final TableField<VDmElementS4Record, String> TREE = createField(DSL.name("tree"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_element_s4.key_element</code>.
     */
    public final TableField<VDmElementS4Record, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_element_s4.key_element_type</code>.
     */
    public final TableField<VDmElementS4Record, Integer> KEY_ELEMENT_TYPE = createField(DSL.name("key_element_type"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_element_s4.key_parent_element</code>.
     */
    public final TableField<VDmElementS4Record, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_element_s4.dn</code>.
     */
    public final TableField<VDmElementS4Record, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_element_s4.order_nr</code>.
     */
    public final TableField<VDmElementS4Record, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_element_s4.short_name</code>.
     */
    public final TableField<VDmElementS4Record, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_element_s4.is_public</code>.
     */
    public final TableField<VDmElementS4Record, Integer> IS_PUBLIC = createField(DSL.name("is_public"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_element_s4.hier_lang</code>.
     */
    public final TableField<VDmElementS4Record, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    private VDmElementS4(Name alias, Table<VDmElementS4Record> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDmElementS4(Name alias, Table<VDmElementS4Record> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dm_element_s4" as  WITH RECURSIVE q(key_element, key_parent_element, tree) AS (
                SELECT t_core_element_hierarchy.key_element,
                   t_core_element_hierarchy.key_parent_element,
                   t_core_element_hierarchy.dn
                  FROM common_dd.t_core_element_hierarchy
                 WHERE (t_core_element_hierarchy.dn = 'SHIP.SHIP4'::text)
               UNION ALL
                SELECT h.key_element,
                   h.key_parent_element,
                   ((q_1.tree || '.'::text) || h.short_name)
                  FROM (common_dd.t_core_element_hierarchy h
                    JOIN q q_1 ON ((q_1.key_element = h.key_parent_element)))
               )
        SELECT q.tree,
           q.key_element,
           t.key_element_type,
           q.key_parent_element,
           t.dn,
           t.order_nr,
           t.short_name,
           t.is_public,
           t.hier_lang
          FROM (q
            LEFT JOIN common_dd.t_core_element_hierarchy t ON ((t.key_element = q.key_element)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_element_s4</code> table reference
     */
    public VDmElementS4(String alias) {
        this(DSL.name(alias), V_DM_ELEMENT_S4);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_element_s4</code> table reference
     */
    public VDmElementS4(Name alias) {
        this(alias, V_DM_ELEMENT_S4);
    }

    /**
     * Create a <code>common_dd.v_dm_element_s4</code> table reference
     */
    public VDmElementS4() {
        this(DSL.name("v_dm_element_s4"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDmElementS4 as(String alias) {
        return new VDmElementS4(DSL.name(alias), this);
    }

    @Override
    public VDmElementS4 as(Name alias) {
        return new VDmElementS4(alias, this);
    }

    @Override
    public VDmElementS4 as(Table<?> alias) {
        return new VDmElementS4(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmElementS4 rename(String name) {
        return new VDmElementS4(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmElementS4 rename(Name name) {
        return new VDmElementS4(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmElementS4 rename(Table<?> name) {
        return new VDmElementS4(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmElementS4 where(Condition condition) {
        return new VDmElementS4(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmElementS4 where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmElementS4 where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmElementS4 where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmElementS4 where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmElementS4 where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmElementS4 where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmElementS4 where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmElementS4 whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmElementS4 whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
